chiark / gitweb /
81accebf0f6f11d53639af725298416606102e33
[dgit.git] / tests / lib
1 #
2
3 exec 2>&1
4 set -x
5 set -o pipefail
6
7 . tests/lib-core
8 . tests/lib-restricts
9
10 t-report-failure () {
11         set +x
12         rc=$1
13         cat <<END >&2
14 TEST FAILED
15 funcs: ${FUNCNAME[*]}
16 lines: ${BASH_LINENO[*]}
17 files: ${BASH_SOURCE[*]}
18 END
19         exit 16
20 }
21
22 trap 'test $? = 0 || t-report-failure' EXIT
23
24 t-set-intree
25
26 : ${DGIT_TEST_DEBUG=-D}
27 export DGIT_TEST_DEBUG
28
29 export GIT_COMMITTER_DATE='1440253867 +0100'
30 export GIT_AUTHOR_DATE='1440253867 +0100'
31
32 root=`pwd`
33 troot=$root/tests
34 testname="${DGIT_TEST_TESTNAME-${0##*/}}"
35
36 tmp=$ADTTMP
37 if [ x"$tmp" = x ]; then
38         mkdir -p tests/tmp
39         tmpbase=$troot/tmp
40         tmp=tests/tmp/$testname
41         rm -rf $tmp
42         mkdir $tmp
43 fi
44 cd $tmp
45
46 tmp=`pwd`
47
48 t-set-using-tmp
49
50 env -0 >$tmp/.save-env
51
52 ln -f $troot/ssh ssh
53
54 mkdir -p $tmp/gnupg
55 cp $troot/gnupg/* $tmp/gnupg
56 chmod go-rw $tmp/gnupg/*
57
58 export DEBCHANGE_VENDOR=dpkg
59
60 mkdir -p $tmp/incoming
61 cat <<END >$tmp/dput.cf
62 [test-dummy]
63 method                  = local
64 incoming                = $tmp/incoming
65 run_dinstall            = 0
66 END
67
68 : ${tagpfx:=test-dummy}
69 : ${suitespecs:=sid:unstable}
70
71 t-git-next-date () {
72         GIT_COMMITTER_DATE="$(( ${GIT_COMMITTER_DATE%% *} + 1 )) ${GIT_COMMITTER_DATE#* }"
73         GIT_AUTHOR_DATE="$GIT_COMMITTER_DATE"
74 }
75
76 t-expect-fail () {
77         local mpat="$1"; shift
78
79         set +o pipefail
80         LC_MESSAGES=C "$@" 2>&1 | tee $tmp/t.output
81         local ps="${PIPESTATUS[*]}"
82         set -o pipefail
83
84         case $ps in
85         "0 0")  fail "command unexpectedly succeeded (instead of: $mpat)" ;;
86         *" 0")  ;;
87         *)      fail "tee failed"  ;;
88         esac
89
90         t-grep-mpat "$mpat" $tmp/t.output
91 }
92
93 t-grep-mpat () {
94         local mpat="$1"
95         local file="$2"
96
97         local grepper=fgrep
98         case "$mpat" in
99         [A-Z]:*)
100                 case "$mpat" in
101                 E:*)    grepper=egrep   ;;
102                 F:*)    grepper=fgrep   ;;
103                 *)      fail "bad mpat prefix in $mpat";;
104                 esac
105                 mpat=${mpat#[A-Z]:}
106                 ;;
107         esac
108
109         $grepper -e "$mpat" "$file" ||
110                 fail "message not found"
111 }
112
113 t-expect-push-fail () {
114         local mpat="$1"; shift
115
116         local triedpush=`git rev-parse HEAD`
117
118         t-reporefs pre-push
119         t-expect-fail "$mpat"  "$@"
120         t-reporefs post-push
121         diff $tmp/show-refs.{pre,post}-push
122
123         t-git-objects-not-present '' $triedpush
124
125         eval "$t_expect_push_fail_hook"
126 }
127
128 t-git-objects-not-present () {
129         # t-git-objects-not-present GITDIR|'' OBJID [...]
130         # specifying '' means the repo for package $p
131         local gitdir="${1-$dgitrepo}"
132         local obj
133         if ! [ -e "$gitdir" ]; then return; fi
134         for obj in "$@"; do
135                 GIT_DIR=$gitdir \
136                 t-expect-fail 'unable to find' \
137                 git cat-file -t $obj
138         done
139 }
140
141 t-reporefs () {
142         local whichoutput=$1; shift
143         local whichrepo=${1-$dgitrepo}
144         local outputfile="$tmp/show-refs.$whichoutput"
145         (set -e
146          exec >"$outputfile"
147          if test -d $whichrepo; then
148                 cd $whichrepo
149                 git show-ref |sort
150         fi)
151 }
152
153 t-untar () {
154         local tarfile=$1.tar
155         local edittree=$1.edit
156         if test -d "$edittree"; then
157                 cp -a "$edittree"/* .
158         else
159                 tar xf "$tarfile"
160         fi
161 }
162
163 t-worktree () {
164         rm -rf $p
165         t-untar $troot/worktrees/${p}_$1
166 }
167
168 t-select-package () {
169         p=$1
170         dgitrepo=$tmp/git/$p.git
171 }
172
173 t-git () {
174         t-select-package $1
175         v=$2
176         mkdir -p $tmp/git
177         local gs=$troot/git-srcs/${p}_$v.git
178         (set -e; cd $tmp/git; t-untar $gs)
179 }
180
181 t-git-none () {
182         mkdir -p $tmp/git
183         (set -e; cd $tmp/git; tar xf $troot/git-template.tar)
184 }
185
186 t-git-merge-base () {
187         git merge-base $1 $2 || test $? = 1
188 }
189
190 t-has-ancestor () {
191         local now=`git rev-parse HEAD`
192         local ancestor=`git rev-parse $1^{}`
193         local mbase=`t-git-merge-base $ancestor $now`
194         if [ x$mbase != x$ancestor ]; then
195                 fail "not ff $ancestor..$now, $mbase != $ancestor"
196         fi
197 }
198
199 t-prep-newpackage () {
200         t-select-package $1
201         v=$2
202         t-archive-none $p
203         t-git-none
204         t-worktree $v
205         cd $p
206         if ! git show-ref --verify --quiet refs/heads/master; then
207                 git branch -m dgit/sid master
208                 git remote rm dgit
209         fi
210         cd ..
211 }
212
213 t-archive-none () {
214         t-select-package $1
215         mkdir -p $tmp/aq/dsc_in_suite $tmp/mirror/pool/main
216
217         : >$tmp/aq/suites
218         local jsondelim="["
219
220         local suitespec
221         for suitespec in $suitespecs; do
222                 local suite=${suitespec%%:*}
223                 local sname=${suitespec#*:}
224
225                 >$tmp/aq/package.$suite.$p
226                 t-archive-updated $suite $p
227
228                 >$tmp/aq/package.new.$p
229                 t-archive-updated new $p
230
231                 ln -s $suite $tmp/aq/dsc_in_suite/$sname
232
233                 cat <<END >>$tmp/aq/suites
234 $jsondelim
235    {
236       "archive" : "ftp-master",
237       "codename" : "$suite",
238       "components" : [
239          "main",
240          "contrib",
241          "non-free"
242       ],
243       "name" : "$sname",
244       "dakname" : "$sname"
245 END
246
247                 jsondelim="   },"
248
249         done
250         cat <<END >>$tmp/aq/suites
251     }
252 ]
253 END
254 }
255
256 t-archive-updated () {
257         local suite=$1
258         local p=$2
259         local suitedir=$tmp/aq/dsc_in_suite/$suite
260         mkdir -p $suitedir
261         perl <$tmp/aq/package.$suite.$p >$suitedir/$p -wne '
262                 use JSON;
263                 use strict;
264                 our @v;
265                 m{^(\S+) (\w+) ([^ \t/]+)/(\S+)} or die;
266                 push @v, {
267                         "version" => "$1",
268                         "sha256sum" => "$2",
269                         "component" => "$3",
270                         "filename" => "$4",
271                 };
272                 END {
273                         my $json = JSON->new->canonical();
274                         print $json->encode(\@v) or die $!;
275                 }
276         '
277 }
278
279 t-archive-process-incoming () {
280         local suite=$1
281         mv $tmp/incoming/${p}_${v}[._]* $tmp/mirror/pool/main/
282         t-archive-query "$suite"
283 }
284
285 t-archive-query () {
286         local suite=${1-sid}
287         local dscf=main/${p}_${v}.dsc
288         local sha=`sha256sum <$tmp/mirror/pool/$dscf`
289         echo "${v} ${sha%  -} $dscf" >>$tmp/aq/package.$suite.${p}
290         t-archive-updated $suite $p
291 }
292
293 t-archive () {
294         t-archive-none $1
295         v=$2
296         local dscf=${p}_$2.dsc
297         rm -f $tmp/mirror/pool/main/${p}_*
298         ln $troot/pkg-srcs/${p}_${2%-*}* $tmp/mirror/pool/main/
299         t-archive-query
300         rm -rf $tmp/extract
301         mkdir $tmp/extract
302         (set -e; cd $tmp/extract; dpkg-source -x ../mirror/pool/main/$dscf)
303 }
304
305 t-git-dir-time-passes () {
306         touch -d 'last year' $dgitrepo
307 }
308
309 t-git-dir-check () {
310         local gitdir=$dgitrepo
311         case "$1" in
312         enoent)
313                 if test -e "$gitdir"; then fail "$gitdir exists"; fi
314                 return
315                 ;;
316         public) wantstat='7[75]5' ;;
317         secret) wantstat='7[70]0' ;;
318         *)      fail "$1 t-git-dir-check ?" ;;
319         esac
320         gotstat=`stat -c%a $gitdir`
321         case "$gotstat" in
322         *$wantstat) return ;;
323         *)      fail "$gitdir has mode $gotstat, expected $wantstat" ;;
324         esac
325 }
326
327 t-rm-dput-dropping () {
328         rm -f $tmp/${p}_${v}_*.upload
329 }
330
331 t-dgit () {
332         local dgit=${DGIT_TEST-dgit}
333         pwd
334         : '
335 {{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{'
336         $dgit --dgit=$dgit --dget:-u --dput:--config=$tmp/dput.cf \
337                 -dtest-dummy $DGIT_TEST_OPTS $DGIT_TEST_DEBUG \
338                 -k39B13D8A "$@"
339         : '}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}
340 '
341 }
342
343 t-diff-nogit () {
344         diff --exclude=.git --exclude=.pc -ruN $*
345 }
346
347 t-files-notexist () {
348         local f
349         for f in "$@"; do
350                 if [ -e $f ]; then
351                         fail "$f exists!"
352                 fi
353         done
354 }
355
356 t-cloned-fetched-good () {
357         t-diff-nogit ../extract/$p-${v%-*} .
358         t-clean-on-branch dgit/sid
359         t-refs-same-start
360         t-refs-same \
361                 refs/heads/dgit/sid \
362                 refs/remotes/dgit/dgit/sid
363         t-refs-notexist refs/dgit/unstable refs/remotes/dgit/dgit/unstable
364 }
365
366 t-output () {
367         printf "%s\n" "$1" >$tmp/t.want
368         shift
369         "$@" >$tmp/t.got
370         diff $tmp/t.want $tmp/t.got
371 }
372
373 t-clean-on-branch () {
374         t-output "## $1" git status -b --porcelain
375 }
376
377 t-setup-done () {
378         local savevars=$1
379         local savedirs=$2
380         local importeval=$3
381
382         exec 4>$tmp/IMPORT.new
383
384         local vn
385         for vn in $savevars; do
386                 perl >&4 -I. -MDebian::Dgit -e '
387                         printf "%s=%s\n", $ARGV[0], shellquote $ARGV[1]
388                 ' $vn "$(eval "printf '%s\n' \"\$$vn\"")"
389         done
390
391         (set -e; cd $tmp; tar cf IMPORT.tar $savedirs)
392
393         printf >&4 "\n%s\n" "$importeval"
394
395         mv -f $tmp/IMPORT.new $tmp/IMPORT
396 }
397
398 t-setup-import () {
399         local setupname=$1
400
401         if [ "x$tmpbase" = x ]; then
402                 # ADTTMP was set on entry to tests/lib, so we
403                 # are not sharing tmp area between tests
404                 setupsrc="$tmp"
405         else
406                 setupsrc="$tmpbase/$setupname"
407         fi
408
409         local simport="$setupsrc/IMPORT"
410
411         if ! [ -e "$simport" ]; then
412                 with-lock-ex -w "$simport.lock" \
413                 xargs -0 -a $tmp/.save-env \
414                 bash -xec '
415                         cd "$1"; shift
416                         setupname="$1"; shift
417                         simport="$1"; shift
418                         if [ -e "$simport" ]; then exit 0; fi
419                         env - "$@" \
420                         "tests/setup/$setupname"
421                 ' x "$root" "$setupname" "$simport"
422         fi
423
424         if [ "x$setupsrc" != "x$tmp" ]; then
425                 (set -e; cd $tmp; tar xf "$simport.tar")
426         fi
427
428         . "$simport"
429 }
430
431 t-git-get-ref-exact () {
432         local ref=$1
433         # does not dereference, unlike t-git-get-ref
434         case "$ref" in
435         refs/*) ;;
436         *) fail "t-git-get-ref-exact bad $ref" ;;
437         esac
438         git for-each-ref --format='%(objectname)' "[r]efs/${ref#refs/}"
439 }
440
441 t-git-get-ref () {
442         local ref=$1
443         case "$ref" in
444         refs/*) ;;
445         *) fail "t-git-get-ref bad $ref" ;;
446         esac
447         (git show-ref -d $1 || test $? = 1) | perl -ne '
448                 $x = $1 if m#^(\w+) \Q'$1'\E(?:\^\{\})?$#;
449                 END { print "$x\n" if length $x; }
450         '
451 }
452
453 t-ref-same-exact () {
454         local name="$1"
455         local val=`t-git-get-ref-exact $name`
456         t-ref-same-val "$name" $val
457 }
458
459 t-ref-same () {
460         local name="$1"
461         local val=`t-git-get-ref $name`
462         t-ref-same-val "$name" $val
463 }
464
465 t-ref-head () {
466         local val=`git rev-parse HEAD`
467         t-ref-same-val HEAD $val
468 }
469
470 t-ref-same-val () {
471         local name="$1"
472         local val=$2
473         case "$t_ref_val" in
474         '')             ;;
475         "$val")         ;;
476         *)              fail "ref varies: $name:\
477  ${val:-nothing} != ${t_ref_val:-nothing}" ;;
478         esac
479         t_ref_val="$val"
480 }
481
482 t-refs-same-start () {
483         t_ref_val=''
484 }
485
486 t-refs-same () {
487         local g
488         for g in $*; do
489                 t-ref-same $g
490         done
491 }
492
493 t-refs-notexist () {
494         local val
495         for g in $*; do
496                 val=`t-git-get-ref $g`
497                 if [ "x$val" != x ]; then
498                         fail "ref $g unexpectedly exists ($val)"
499                 fi
500         done
501 }
502
503 t-v-tag () {
504         echo refs/tags/$tagpfx/${v//\~/_}
505 }
506
507 t-check-pushed-master () {
508         local master=`t-git-get-ref refs/heads/master`
509         if [ x$master = x$t_ref_val ]; then return; fi
510         if [ x$master = x ]; then fail "failed to push master"; fi
511         # didn't update master, it must be not FF
512         local mbase=`t-git-merge-base $master $t_ref_val`
513         if [ x$mbase = x$master ]; then fail "failed to ff master"; fi
514 }
515
516 t-pushed-good () {
517         local branch=$1
518         local suite=${2:-sid}
519         t-ref-dsc-dgit
520         t-refs-same \
521                 refs/heads/$branch \
522                 `t-v-tag` \
523                 refs/remotes/dgit/dgit/$suite
524         t-refs-notexist \
525                 refs/heads/dgit/unstable \
526                 refs/remotes/dgit/dgit/unstable
527         (set -e; cd $dgitrepo
528          t-refs-same \
529                 refs/dgit/$suite \
530                 `t-v-tag`
531          ${t_check_pushed_master:- : NOT-DRS-NO-CHECK-PUSHED-MASTER}
532          t-refs-notexist \
533                 refs/dgit/unstable
534         )
535         git verify-tag `t-v-tag`
536 }
537
538 t-commit-build-push-expect-log () {
539         local msg=$1
540         local mpat=$2
541         t-commit "$msg"
542         t-dgit build
543         LC_MESSAGES=C \
544         t-dgit push --new 2>&1 |tee $tmp/push.log
545         t-grep-mpat "$mpat" $tmp/push.log
546 }
547
548 t-822-field () {
549         local file=$1
550         local field=$2
551         perl -e '
552                 use Dpkg::Control::Hash;
553                 my $h = new Dpkg::Control::Hash allow_pgp=>1;
554                 $h->parse(\*STDIN,"'"$file"'");
555                 my $val = $h->{"'$field'"},"\n";
556                 die "'"$file $field"'" unless defined $val;
557                 print $val,"\n";
558         ' <$file
559 }
560
561 t-stunt-envvar () {
562         local var=$1
563         local tstunt=$2
564         eval '
565                 case "'$var'" in
566                 "$tstunt:"*)    ;;
567                 *":$tstunt:"*)  ;;
568                 *)              '$var'="$tstunt:$'$var'" ;;
569                 esac
570         '
571 }
572
573 t-tstunt () {
574         local tstunt=$tmp/tstunt
575         t-stunt-envvar PATH $tstunt
576         t-stunt-envvar PERLLIB $tstunt
577         local f
578         for f in "$@"; do
579                 f="./$f"
580                 local d="$tstunt/${f%/*}"
581                 mkdir -p $d
582                 ln -sf "$troot/tstunt/$f" "$d"/.
583         done
584 }
585
586 t-tstunt-parsechangelog () {
587         t-tstunt dpkg-parsechangelog Dpkg/Changelog/Parse.pm
588 }
589
590 t-ref-dsc-dgit () {
591         local dsc=${p}_${v}.dsc
592         local val=`t-822-field $tmp/incoming/$dsc Dgit`
593         perl -e '$_=shift @ARGV; die "$dsc Dgit $_ ?" unless m/^\w+\b/;' "$val"
594         t-ref-same-val $dsc "$val"
595 }
596
597 t-apply-diff () {
598         local v1=$1
599         local v2=$2
600         (cd $troot/pkg-srcs;
601          debdiff ${p}_${v1}.dsc ${p}_${v2}.dsc || test $? = 1) \
602          | patch -p1 -u
603 }
604
605 t-gbp-unapplied-pq2qc () {
606         # does `gbp pq export'
607         # commits the resulting debian/patches on  qc/BRANCH
608         # leaves us on qc/BRANCH (eg "qc/quilt-tip"))
609         # qc/BRANCH is not fast-forwarding
610
611         gbp pq export
612
613         branch=`git symbolic-ref HEAD`
614         branch=${branch#refs/heads/}
615
616         case "$branch" in
617         */*) fail "unexpected branch $branch" ;;
618         esac
619
620         git branch -f qc/$branch
621         git checkout qc/$branch
622         git add debian/patches
623         git commit -m 'Commit patch queue'
624 }
625
626 t-gbp-example-prep () {
627         t-archive example 1.0-1
628         t-git-none
629         t-worktree 1.0
630
631         cd example
632
633         t-dgit fetch
634
635         git-checkout -b patch-queue/quilt-tip-2 patch-queue/quilt-tip
636         gbp pq rebase
637
638         echo '/* some comment */' >>src.c
639         git add src.c
640         git commit -m 'Add a comment to an upstream file'
641
642         t-gbp-unapplied-pq2qc
643
644         t-commit 'some updates' 1.0-2
645
646         git merge -s ours \
647                 -m 'Pseudo-merge to make descendant of archive' \
648                 remotes/dgit/dgit/sid
649 }
650
651 t-commit () {
652         local msg=$1
653         v=${2:-1.$revision}
654         dch -v$v --distribution ${3:-unstable} "$1"
655         git add debian/changelog
656         debcommit
657         revision=$(( ${revision-0} + 1 ))
658 }
659
660 t-git-config () {
661         git config --global "$@"
662 }
663
664 t-drs () {
665         export DGIT_TEST_TROOT=$troot
666  t-git-config dgit-distro.test-dummy.git-url "ext::$troot/drs-git-ext %S "
667  t-git-config dgit-distro.test-dummy.git-check true
668  t-git-config dgit-distro.test-dummy.git-create true
669  t-git-config dgit-distro.test-dummy.dgit-tag-format old,new
670         cp $troot/gnupg/{dd.gpg,dm.gpg,dm.txt} $tmp/.
671         cp $troot/suites $tmp/.
672         cp $troot/suites $tmp/suites-master
673
674         export t_check_pushed_master=t-check-pushed-master
675
676         drs_dispatch=$tmp/distro=test-dummy
677         mkdir $drs_dispatch
678
679         if [ "x$DGIT_TEST_INTREE" != x ]; then
680                 ln -sf "$DGIT_TEST_INTREE" $drs_dispatch/dgit-live
681         fi
682
683         ln -sf $tmp/git $drs_dispatch/repos
684         ln -sf $tmp/suites $tmp/suites-master $tmp/dm.txt $drs_dispatch/
685         mkdir -p $drs_dispatch/keyrings
686         ln -sf $tmp/dd.gpg $drs_dispatch/keyrings/debian-keyring.gpg
687         ln -sf $tmp/dm.gpg $drs_dispatch/keyrings/debian-maintainers.gpg
688         ln -sf /bin/true $drs_dispatch/policy-hook
689 }
690
691 t-newtag () {
692  export tagpfx=archive/test-dummy
693  t-git-config dgit-distro.test-dummy.dgit-tag-format new
694 }
695 t-oldtag () {
696  t-git-config dgit-distro.test-dummy.dgit-tag-format old
697 }
698
699 t-dsd () {
700         t-drs
701  t-git-config dgit-distro.test-dummy.ssh "$troot/dsd-ssh"
702  t-git-config dgit-distro.test-dummy.git-check ssh-cmd
703  t-git-config dgit-distro.test-dummy.git-create true
704  t-git-config dgit-distro.test-dummy.git-url \
705                 "ext::$troot/dsd-ssh X %S /dgit/test-dummy/repos"
706
707  t-git-config dgit-distro.test-dummy.diverts.drs /drs
708  t-git-config dgit-distro.test-dummy/drs.ssh "$troot/ssh"
709  t-git-config dgit-distro.test-dummy/drs.git-url $tmp/git
710  t-git-config dgit-distro.test-dummy/drs.git-check ssh-cmd
711  t-git-config dgit-distro.test-dummy/drs.git-create ssh-cmd
712
713         echo 'no-such-package* drs' >$drs_dispatch/diverts
714 }
715
716 t-policy-admin () {
717         ${DGIT_INFRA_PFX}dgit-repos-admin-debian --repos $tmp/git "$@"
718 }
719
720 t-policy-nonexist () {
721         ln -sf no-such-file-or-directory $drs_dispatch/policy-hook
722 }
723
724 t-make-hook-link () {
725         local hook=$1 # in infra/
726         local linkpath=$2
727         hook=${DGIT_INFRA_PFX}$hook
728         case $hook in
729         */*)    ;;
730         *)      hook=`type -P $hook` ;;
731         esac
732         ln -sf "$hook" $linkpath
733 }
734
735 t-policy () {
736         local policyhook=$1
737         t-make-hook-link $policyhook $drs_dispatch/policy-hook
738 }
739
740 t-debpolicy () {
741         t-dsd
742         t-policy dgit-repos-policy-debian
743
744         mkdir $tmp/git
745         t-policy-admin create-db
746 }
747
748 t-policy-periodic () {
749         ${DGIT_REPOS_SERVER_TEST-dgit-repos-server} \
750                 test-dummy $drs_dispatch '' --cron
751 }
752
753 t-restrict () {
754         local restriction=$1
755         (cd $root; t-restriction-$restriction >&2)
756 }
757
758 t-dependencies () {
759         : "Hopefully installed: $*"
760 }
761
762 t-chain-test () {
763         local ct=$1
764         local d=${0%/*}
765         cd $root
766         export DGIT_TEST_TESTNAME="$testname"
767         export ADTTMP=$tmp
768         exec "$d/$ct"
769 }       
770
771 t-alt-test () {
772         local t=${0##*/}
773         t-${t%%-*}
774         t-chain-test "${t#*-}"
775 }